Changelog
---------
1.5.0:
-ADDED:  Config option to render plants on crop sticks as a TESR (might improve FPS if you have FPS issues with large farms)
-ADDED:  Config option to disable sounds when interacting with crop sticks (client side only)
-ADDED:  Compat for Gany's Nether plants
-ADDED:  Compat for Gany's Surface plants
-ADDED:  Compat for Et Futurum plants
-ADDED:  Compat for Calculator plants
-ADDED:  Compat for Harder Wildlife plants
-ADDED:  Mutation logic is now exposed to the API and can be changed or overridden
-ADDED:  Right clicking a water pad with a shovel will now turn it back to dirt
-ADDED:  A config option to only allow the creation of water pads while sneaking
-ADDED:  Compat for Hydraulicraft harvesters
-CHANGE: Clippings can now be planted on cross crops (similarly to seeds)
-CHANGE: Removed the compat module for RotaryCraft as Reika will be adding this from his side (you might want to remove all your canola planted on crop sticks before updating)
-CHANGE: Changed the way strings are split in the gui to have better readability for chinese localizations
-CHANGE: ICropPlants from other mods registered through the API will now have a higher priority than ICropPlants from other mods registered within Agricraft's code.
-CHANGE: Wrote proper javadoc for the ICropPlant API interface
-FIXED:  NPE when scanning the ore dictionary for fruits (Damn you null stacks)
-FIXED:  Rare NPE when part of a tank multiblock is loaded, while the main component isn't
-FIXED:  Rare NPE when breaking a tank while raining
-FIXED:  Weird harvesting behaviour with Botania drum of the wild
-FIXED:  Issues with witchery seeds
-FIXED:  Wrong drops from Resourceful Crops plants
-FIXED:  Sprinkler not spinning when particles are disabled
-FIXED:  NPE when requesting documentation for the 'isAnalyzed()' method in the peripheral GUI
-FIXED:  Peripheral dropping a regular seed analyzer
-FIXED:  A bug where tanks and channels would void/dupe water when setup in certain a configuration
-FIXED:  Crash where clippings would crash the client if the seed doesn't have any drops.

1.4.6
-ADDED:  The peripheral should now also work for OpenComputers
-ADDED:  Support for ResourcefulCrops
-ADDED:  API implementation example
-ADDED:  Added config option to disable specific NEI handlers (config setting is enforced via the server)
-ADDED:  Waila tooltips to seed storage & analyzer
-ADDED:  Placing cross crops will make wood sound
-ADDED:  Placing crop sticks while sneaking will now instantly create cross crops
-ADDED:  Support for Garden Stuff's candelilla crop
-ADDED:  Support for Millenaire's crops
-ADDED:  Support for Pam's Harvest the Nether crops
-ADDED:  Support for The Kitchen Mod crops
-CHANGE: Updated Botania drum/horn of the wild interaction: crops will now be harvested instead of uprooted
-CHANGE: Updated to Forge 10.13.4.1566
-CHANGE: [API] IGrowthRequirement is now specified via the ICropPlant it applies to
-FIXED:  Changed the way growth stages are rendered in the journal, fixing rendering for animated textures
-FIXED:  Tanks in greenhouses not correctly forming a multiblock on world generation
-FIXED:  Plants being able to be bonemealed while sneaking even though they shouldn't be
-FIXED:  Blue Power flax not dropping fruit on harvest
-FIXED:  NPE when storing Canola seeds in Seed Storage
-FIXED:  Seeds no longer have to be instance of ItemSeeds to be able to change the base block with MineTweaker (no idea how this survived so long)
-FIXED:  Seed icons rendering wrongly for some IIcons
-FIXED:  Bugs concerning automatic input and output with Seed Storages and Analyzers
-FIXED:  Crash when Botania is not present
-FIXED:  Weeds being removed as long as you don't have an empty hand with rakes enabled
-FIXED:  [HOTFIX] crash on startup when plants are registered via the API

1.4.5
-ADDED:  Support for Agriculture 2
-ADDED:  Config option to disable mod specific fruit drops
-ADDED:  Descriptions for the new HC and PMP seeds
-ADDED:  Brightness bar in the journal displaying what brightness a plant needs
-ADDED:  Missing mutations for some Harvestcraft and PMP seeds
-FIXED:  MineTweaker support for weed raking drops having wrong import
-FIXED:  Weird behaviour for some API methods
-FIXED:  Weird lighting when rendering (thanks HenryLoenwind)
-FIXED:  Lapis not growing

1.4.4
-ADDED:  Configurable option for weeds to drop certain items when raked (can be fully MineTweaked)
-ADDED:  Client side config option to change how stats are displayed (also added an API method to change it)
-CHANGE: Generified the way growth requirements search for metadata (fixes compatibility with GrechTech ores)
-CHANGE: When scanning the ore dictionary for seed/fruit combinations the mod id is now taken into account (except when told not to): no more Natura berries dropping from HC crops
-CHANGE: Rewrote ComputerCraft API methods: some will now have direction as an optional parameter, if it is not given, the method will apply to the specimen in the analyzer (this had as consequence that some methods were merged)
-FIXED:  ArrayIndexOutOfBoundsException and NullPointerException when breaking tank multi blocks under certain conditions
-FIXED:  Crash with Psychedelicraft coffee seeds
-FIXED:  Quirks with the seed storage when automatically inserting item stacks (hoppers, pipes, transfer nodes, ... )
-FIXED:  Inverted boolean return for an API method

1.4.3
-CHANGE: Entirely rewrote the multi-block code fixing a lot of bugs and improving performance.

1.4.2
-ADDED:  A recipe for the clipper
-ADDED:  Config option to disable registering of crop products into the ore dictionary
-ADDED:  Config option to disable particles
-FIXED:  The soil and base block requirements for custom crops will actually have fuzzy metadata when no metadata is specified instead of defaulting to 0
-FIXED:  Fixed error with the parent config numbers
-FIXED:  Fruits added via MineTweaker will be registered to the OreDictionary correctly
-FIXED:  Single tanks not accepting water

1.4.1
-CHANGE: Optimized the peripheral's performance a bit
-CHANGE: Optimized the journal's gui code
-CHANGE: Split the difficulty setting in two: one to define what are considered valid parents for stat inheritance, and one to define if non-parents affect stat gain negatively
-ADDED:  When only the parents are discovered, the journal will now render a mutation with an undiscovered result
-ADDED:  Config option to only allow stat inheritance from identical crops
-ADDED:  Hardcore stat breeding: 1 parent: 3/4 decrement, 1/4 nothing. 2 parents: 2/4 decrement, 1/4 nothing, 1/4 increment. 3 parents: 1/4 decrement, 1/2 nothing, 1/4 increment.
-ADDED:  Config options to disable the trowel and the magnifying glass
-ADDED:  Clipper item: use on crops to get a clipping, a clipping can be planted on crop sticks to get an identical sprout. Success is dependent on strength stat (credits for texture to skullygamingmc)
-ADDED:  Support for the new version of Magical Crops' fertilizer
-FIXED:  Crash involving the peripheral
-FIXED:  Updated fr_FR.lang (Mazdallier)
-FIXED:  Crash when crossbreeding
-FIXED:  Sugarcane requires sand again instead of farmland
-FIXED:  Mutations not being synced to players connecting to a local LAN world

1.4.0
-CHANGE: Updated to Forge 10.13.4.1448
-CHANGE: Rewrote the crop system to prevent crashing
-CHANGE: Rewrote tanks for major performance increase
-CHANGE: Condense all custom wood entries into one in NEI
-CHANGE: Seed analyser will now accept analysed seeds
-CHANGE: Crops will now be displayed as "Crop Sticks"
-CHANGE: Resource crops are now enabled by default
-CHANGE: Reordered the configuration options for easier finding of options
-CHANGE: Clients will now use mutation configs from the server
-CHANGE: Villager ID is now assigned to the first free id
-CHANGE: The AgriCraft villager now has a good looking skin (thanks SkeletonPunk)
-CHANGE: Botania crops now require podzol as soil
-CHANGE: Changed default number of crops per craft to 4
-CHANGE: The journal will now display parent and child mutations separated from each other
-CHANGE: Tweaked lighting when rendering custom wood blocks
-CHANGE: New textures for the rakes, trowel and magnifying glass (credits to MechWarrior99)
-ADDED:  API (many thanks to HenryLoenwind)
-ADDED:  Missing mutations for Harvestcraft crops (Strawberry, Spinach, White Mushroom)
-ADDED:  Resource crop for nether quartz
-ADDED:  Config option to only make mature crops drop seeds to encourage trowel usage (false by default)
-ADDED:  Config option to make crop sticks get destroyed when they are broken with weeds on them to encourage rake usage (false by default)
-ADDED:  Config options to change the spawn rates of greenhouses
-ADDED:  Blood Magic can now auto-harvest crops with the reap of the harvest moon
-ADDED:  Crops for Thaumcraft: shimmerleaf, cinderpearl, vishroom and taintroot
-ADDED:  Crops for Ars Magica 2: cerublossom, desert nova, tarma root, aum, wakebloom
-ADDED:  Button in Seed Analyzer GUI to read the journal
-ADDED:  Some crops (flowers, cactus, ...) can be sheared to get the flower instead of the fruit
-ADDED:  Compatibility for AppleMilkTea (mint)
-ADDED:  Compatibility for RotaryCraft (canola)
-ADDED:  Compatibility for Immersive Engineering (hemp)
-ADDED:  Compatibility for Biomes O Plenty (turnip)
-ADDED:  Compatibility for Extra Biomes XL (strawberries)
-ADDED:  Compatibility for GrowthCraft Rice
-ADDED:  Compatibility for The Lord of the Rings Mod's crops
-ADDED:  Configuration option for a global growth rate multiplier
-ADDED:  Crops will now allow the use of other items on them when not mature (for example the Hoe of Growth from Thaumcraft)
-ADDED:  AgriCraft seeds can now be squeezed into seed oil with forestry
-ADDED:  A water channel that is a full block, for decoration purposes
-ADDED:  NEI handler for crop products
-ADDED:  A water pad block for aquatic crops (water artichoke, wakebloom, squid plant)
-ADDED:  Config options to disable compatibility per mod
-ADDED:  A config to specify seeds that will ingore the disable vanilla farming rule
-ADDED:  The AgriCraft villager will now search and remove weeds from nearby crops
-ADDED:  A recipe to convert wheat to seeds
-ADDED:  Alternate textures for the botania crops (thanks WolfieWaffle for the textures)
-ADDED:  Seed storage block they will hold infinite seeds of the same type, as long as they are analyzed
-ADDED:  sugarcane can now be planted directly on crop sticks
-ADDED:  Natura bonemeal bags will aoe bonemeal crops
-ADDED:  Decorative blocks for every type of planks: fences, fence gates and grates
-ADDED:  Compatibility for Advent of Ascension crops
-ADDED:  Compatibility for crops with Ancient Warfare crop farms
-ADDED:  Config option for irrigation channel capacity
-ADDED:  Computercraft peripheral to read data from crops in the world
-ADDED:  Mutating sprig from witchery will now work on wheat planted on crop sticks
-FIXED:  Seeds added as drops from tall grass always having weight 10
-FIXED:  Not being able to set max brightness in Minetweaker methods
-FIXED:  Wrong error message in Minetweaker methods
-FIXED:  Seed analyser sending data to client and causing block updates every tick while updating
-FIXED:  Poisonous potatoes not dropping from potatoes
-FIXED:  Stat calculation not obeying the stat cap
-FIXED:  Standalone crops obey growth requirements
-FIXED:  A crash on harvesting after someone removed all the fruits of a crop without adding any new ones
-FIXED:  NEI reverse lookup not working for soils and base blocks
-FIXED:  No more missing texture spam in the console
-FIXED:  Village generation not working
-FIXED:  Recipes being added for non initialized items
-FIXED:  Bug where plants would only drop fruits on the first harvest
-FIXED:  NPE when breaking tanks
-FIXED:  Serverside crash
-FIXED:  A bunch of issues with Custom Crops and MineTweaker compatibility
-FIXED:  Magical Crops beta crops giving null as fruit
-FIXED:  NPE with trowel
-FIXED:  Some localisation issues with journal seed information
-FIXED:  Seed Storage Container crashing on servers
-FIXED:  Seed Storage blocks will now drop their inventory when broken
-FIXED:  Villager "teleporting"
-FIXED:  Weird behaviour with thaumcraft golems
-FIXED:  Tanks and channels not having lighting

1.3.1
-ADDED:  Nitor Wart: a new crop that produces glowstone dust
-CHANGE: Renamed Mushroom Seeds to Spores
-CHANGE: Sprinklers are now less laggy
-FIXED:  Various crashes related to analyzed seeds in the journal after removing mods
-FIXED:  Unable to plant crops on soul sand
-FIXED:  Broken scythes will no longer harvest crops
-FIXED:  Blacklisted seeds bypass disabling of Vanilla farming correctly

1.3.0
-ADDED: Hand Rake tool which, when enabled, is the only thing that can remove weeds
-ADDED: A config option to change the maximum stat cap on crops
-ADDED: A config option to divide the stats on a newly mutated crops
-ADDED: A config option to let the cactus crop produce cactus blocks instead of cactus green
-ADDED: Villagers for the greenhouse (Elec332)
-ADDED: MineTweaker3 support for changing growth requirements
-ADDED: Compatibility with Jaquadro's GardenStuff (crops can be planted on them
-ADDED: zh_CH.lang (3TUSK)
-ADDED: Support for psychedelicraft (Will work when the newer version of Psychedelicraft is released)
-ADDED: Other mods can make their seed/fruit compatible by registering the seed as "seed<YourPlantName>" and the fruit as "crop<YourPlantName>" to the ore dictionary
-ADDED: The particle setting will now decrease the number of particles from the sprinkler
-CHANGE: The background of the seed portrait in the journal is now the required soil
-CHANGE: You can now specify any block as a specific soil for custom crops
-CHANGE: Adding cross-crop sticks won't clear weeds anymore
-CHANGE: Overhauled the way mutation requirements work: instead of setting specific requirements for mutations, you now have to set specific requirements for growing.
-CHANGE: The requirement for a mutation to happen is the same as for growing: A plant can only mutate if it can grow there
-CHANGE: NEI will show the needed soil and required base block (if any) for mutations
-CHANGE: Potatoes sometimes drop poisonous potatoes now
-CHANGE: Register seeds and their produce as seed<Name> and crop<Name> in the ore dictionary
-CHANGE: Spreading from only 1 crop will not cause any stat increases (unless toggled in the config)
-CHANGE: Added a difficulty for increasing stats in the config. 1: all surrounding crops will affect stat increase. 2: Only parent/identical crops will affect stat increase. 3: Same as 2, but other crops will affect stat inheritance negatively
-CHANGE: Made the recipe for crops shaped to prevent conflicts with buildcraft wooden gears
-FIXED: Sprinklers no longer hate railcraft hidden blocks
-FIXED: Moved Botania crops to post init to possibly fix the crops not dropping petals
-FIXED: Nether wart not being recognised as a valid seed (Marcin212)
-FIXED: Sprinkler not stopping when water in the channel above ran out
-FIXED: Waila not showing accurate fluid levels for channel, tank and valve
-FIXED: Fixed crop not re-rendering on changes
-FIXED: Stats are now being reduced on mutating instead of spreading
-FIXED: Seeds being able to be planted on unhydrated farmland while farming was disabled
-FIXED: NEI mutation GUI ignoring soil meta value
-FIXED: Infinite loop when specifying BaseBlock of type 2
-FIXED: Moved resource crops to post-init to enable resource crops for mods that register their ore dictionary entries too late
-FIXED: Cactus crop dropping cactus with metadata 2 if the config option was on
-FIXED: Crash with CoFH
-FIXED: (hopefully) Fixed weird ingot to nugget recipes getting registered
-FIXED: Nether wart always yielding one fruit, regardless of gain level

1.2.2
-ADDED:  TConstruct scythes can be used for aoe harvesting (right click on crops to aoe harvest)
-ADDED:  Cactus and mushroom crops
-ADDED:  Configurable instant-growth for magical fertiliser
-ADDED:  Crops for botania's petals
-ADDED:  Growth rate configuration for sprinkler
-ADDED:  The option to set the soil for a custom crop (this will require you to add one argument to all your custom crops)
-ADDED:  The option to add and remove fruits from custom crops with minetweaker (multiple fruits have are weighted)
-CHANGE: Crops can now be applied on sand and soul sand by default
-CHANGE: Seeds now require the correct soil when being planted on a crop
-CHANGE: Soil whitelist: whitelisted soils only apply to crops that need farmland
-CHANGE: Crops will follow Hunger Overhaul's rules (Squeek502)
-FIXED:  Hard runtime dependency on Botania
-FIXED:  Seeds with identical stats sometimes not stacking
-FIXED:  shapeless custom wood recipes not working correctly
-FIXED:  Vanilla farming only disabling for farmland
-FIXED:  Lag issues regarding the irrigation system (still being looked at)
-FIXED:  Seed duplication bug involving the Seed Analyzer

1.2.1
-Changed AgriCraft creative tab logo
-Fixed certain crops rendering crooked
-Fixed crop lighting
-Changed Sprinkler to use a fixed configurable amount of water
-Added channel valves to irrigation systems
-Overhauled irrigation systems: sprinklers will keep consuming water but there are now valves to close channels
-Added configuration GUIs for some config categories
-Fixed water draining bug in irrigation systems
-Added option to clear all registered seed drops
-Added support for Chococraft gysahls
-Added a config to override seed tiers
-Made Magic Fertiliser from Magical Crops work on tier 4 & 5 crops (can be disabled in the config)
-Botania Horn of the Wild will no longer wipe crops away, instead it will clear them
-Added a config option to disable weeds from taking over plants (they will still spread to nearby empty crops)
-Added Minetweaker support for various aspects of AgriCraft. Check the GitHub wiki for documentation.

1.1.1
-Fixed Null Pointer Exception in certain cases when breaking tanks
-Fixed config reading bug
-Custom Plants will now correctly drop their fruit if their fruit is a seed
-Plants rendering in a cross will now render 4 smaller plants again
-PMP & Natura crops now render with the correct icons again
-Moved custom crops registering to post init to allow other mod items (which might register in init) to be used as drops
-Instead of crashing the game, faulty config entries will be pointed out in the log (back up your old configs and enable regenerate defaults in the main config)
-Updated the NEI handler to show required blocks below/near
-Added a config to specify fertile soils for crops

1.1.0
-Rewrote rendering code to improve performance
-Fixed gardening trowel bug
-Changed Hunger Overhaul compatibility (you need to update HO to newest version as well)

1.0.5
-Fixed crash when disabling vanilla farming
-Fixed servers kicking you out when breaking tanks
-Network optimization for irrigation systems (marcin212)

1.0.4
-Fixed shift-clicking crops crash
-Water residue after breaking a tank now flows
-Fixed a spelling error in the en_US.lang file
-Disabling Vanilla farming in the config actually disables Vanilla farming
-sprinkler now uses oak planks as breaking particles instead of missing textures
-tanks will never fill up in deserts (it can rain in deserts apparently, but it doesn't render the particles)

1.0.3
-Waila and magnifying glass only show stats of analyzed plants
-Sprinklers consume less water and irrigate plants much much slower (it was quite op before)
-Changed the way custom wood recipes are handled, they now show up in NEI
-Sprinkler now always drops the right item
-Tanks, channels and sprinklers are no longer destroyed in one hit
-The math behind irrigation systems is now correct
-Made irrigation systems less network intensive
-In the journal, when a fruit is a block, it now loads the texture correctly
-Fixed some crop rendering derps (Marcin212)
-World gen blocks no longer generate in greenhouses
-Added weeds

0.0.12
-Fixed crash if OreDictionary planks weren't blocks
-Underped resource crops in the configs
-Rewrote mutations
-Added special mutations: either require a specific block near or a base block in order to mutate
-Set magical crops seeds to tier 4
-Added Waila integration for crops, tanks and irrigation channels
-Added gardening trowel: can be used to move plants from one corp to another
-Added magnifying glass: use to inspect crops
-Added journal description for plant mega pack seeds
-Fixed Seed Analyzer not dropping its contents when harvested

0.0.11
-Config option to get more crops per crafting operation
-Added support to translate the journal to other languages
-Fixed a crash with GregTech installed
-Fixed derpy directory on Linux
-Railcraft Hidden Blocks no longer prevent crops from being placed
-Added a config file to override mutation chances for seeds
-Fixed Seed Analyzer crash
-Added a config file to blacklist seeds
-Higher tier seeds will now mutate with lower chances and spread a lot slower to adjacent crosscrops
-Added language support for tooltips
-Added greenhouses to villages (can be disabled in the config)
-Added MFR integration
-Upgraded Forge to 1230
-Added Thaumcraft integration (golem harvesting and aspects)

0.0.10
-Fixed not being able to interact while having seeds in hand
-You now no longer need an empty hand to harvest crops
-Added config option to disable vanilla farming (default is false)
-Finished irrigation systems
-Fixed tanks & irrigation channels always dropping oak wood versions when harvesting them
-Added default mutations for Pam's Weee Flowers
-Added recipes to convert Ex Nihilo seeds to AgriCraft seeds
-Added Plant Mega Pack integration and default mutations
-Changed the recipe for wooden bowls to use slabs (it overlaps with irrigation channels)
-Added config option to disable irrigation systems
-Added French translations (Mazdallier)

0.0.9
-Further work on irrigation systems
-Changed some methods for dropping seeds and fruits in the world when harvesting crops
-AgriCraft should now be compatible with Hunger Overhaul
-Fixed duping bug with Hunger Overhaul installed
-Fixed bonemeal not working with Hunger Overhaul installed

0.0.8
-Added a config option to disable forcing a mutation by using bonemeal on a crosscrop
-Finished water tank multiblock logic
-Added a config for registering seeds to drop from tall grass
-Fixed having to look at a block to open the Agricultural Journal
-Seeds that have been analyzed or have been planted on a crop can no longer be planted on regular farmland
-Finished water tank rendering: the tank renders using the texture from the wood used to craft it
-Fixed trying to configure mutation NEI recipe handler serverside
-Updated to forge 10.13.1.1217
-Changed some things in my TileEntity classes (I suggest you remove your crops and seed analyzers from your world before updating)

0.0.7
-Somewhere a bug creeped in where planted seeds would immediately be fully grown, this is fixed now
-Fixed a bug where crosscrops would mutate in no plant
-Started work on irrigation systems: added tanks (code is there, they are not registered yet)
-Actually runs on servers now
-Added default mutations for resource crops for non-vanilla resources
-Changed Harvestcraft & Natura integration as well as resource crops to be enabled by default

0.0.6
-Added journal
-Fixed being able to bonemeal fully grown crops
-Fixed a derp crash when one plant would get registered twice
-Cleaned up some code (it's still a mess, but just a little bit less of a mess)
-Fixed opening Seed Analyzer gui pausing the game
-Fixed some crops crashing the game while trying to harvest them
-Updated bonemeal logic

0.0.5
-Added resource crops based on what ores have been registered in the ore dictionary
-Fixed plants planted on regular farmland (outside crops) not dropping seeds (stats resetting not fixed yet)
-Prevented Thaumic Tinkerer infused seeds from being planted or analyzed

0.0.4
-Added additional rendering method
-Fixed, under certain conditions, recipes showing up twice in NEI
-Fixed planting Magical Crops seed crash
-Fixed harvesting Magical Crops now yields the correct item
-Looked into Growthcraft integration and it seems there isn't much to integrate
-Fixed a bug where if you only specified 1 mutation it wouldn't be parsed
-Added the ability to add your own custom crops
-You now specify the mutations using the names for seeds you get from NEI
-Added a correction method on the input (old mutation configs will still work)
-Fixed Rendering and drops on Nether Wart
-Fixed NullPointerExceptions when harvesting melons, pumpkins or custom crops

0.0.3
-Fixed a bug where every seed could only mutate from a single set of unique parents
-Added NEI integration
-Added stat inheritance on mutations
-Fixed being able to bonemeal empty crops
-Added using bonemeal on a cross crop triggers a crossover
-Added tooltips on seeds with initialized stats
-Tweaked bounding box of crops
-Reworked and cleaned up code
-Added Seed Analyzer

0.0.2
-Added default mutations for poppy, dandelion, melons, pumpkins & sugarcane
-Fixed plants rendering dark on crops
-Hide crops from NEI
-Added Natura integration
-Added meta in mutation configs
-Merged mutation configs in one file
-Added config option to regenerate default mutation config

0.0.1
-Initial build
